%%This is a part of multi-layered random forest (MLRF) framework

%%merge to clusters so that class separation is maximized
%if the size is less then options.small
function [cl,sizes] = cleanClustersExt(Y,cl,cmat,options)

    cluni = unique(cl);
    sizes = zeros(length(cluni),1);

    for i=1:length(cluni)
        sizes(i) = sum(cl == cluni(i));
    end
    
    tomerge = find(sizes <= options.small);
    
    cmat(tomerge,:) = 0;
    
    if (~isempty(tomerge))
        
        warning('Some clusters will be merged');
        
        for i=1:length(tomerge)
            Y1 = Y(cl == cluni(tomerge(i)));
            %merge to a cluster with the maxim of the elements of this type
            
            [~,idx]=max(cmat(:,Y1),[],1);
            
            cl(cl == cluni(tomerge(i))) = idx;
        end
        
        cluni = unique(cl);
        sizes = zeros(length(cluni),1);
        
        %relabel and recompute sizes
        for i=1:length(cluni)
            cl(cl==cluni(i)) = i;
            sizes(i) = sum(cl == i);
        end       

    end

end