#include <mex.h>

/*returns all combinations of two elements*/
void mexFunction( int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
    if (nrhs<1){
        mexErrMsgTxt("One arguments expected\n");
    }
    
    double *data = mxGetPr(prhs[0]);
    int n = mxGetN(prhs[0]), m = mxGetM(prhs[0]);
    int l = n*m;
    
    if (n!=1 & m!=1){
        mexErrMsgTxt("A vector expected\n");
    }
    
    if (nlhs>0){
        long length = l*(l-1)/2,start,end;
        plhs[0]= mxCreateDoubleMatrix(l*(l-1)/2,2,mxREAL);
        double *out = mxGetPr(plhs[0]);
        
        
        for(int i=0; i<(l-1); i++){
            start = i*l - i*(i+1)/2;
            for(int j=(i+1); j<l; j++){
                out[start + j - (i+1)] = data[i];
                out[length + start + j - (i+1)] = data[j];
            }
        }
    }

}
